// Startup preko Windows-ovih servisa

{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

program Services;

uses
  Windows,
  WinSVC;

function InstallService(const lpServiceName,
                              lpszDisplayName  : String;
                        const dwServiceType,
                              dwStartType,
                              dwErrorControl   : Cardinal;
                        const lpBinaryPathName : String) : Integer;
var
  schSCManager,
  schService   : SC_HANDLE;
begin
  result := 0;

// Otvaramo SCM bazu
  schSCManager := OpenSCManager(nil,                    { oznacava ime kompjutera ciju SCM bazu otvaramo
                                                          default je lokalni kompjuter                    }
                                nil,                    { oznacava ime SCM baze - default je ServicesActive }
                                SC_MANAGER_ALL_ACCESS); { setuje privilegije koje imamo nad SCM }

// U slucaju da nismo mogli da je otvorimo, izlazimo iz fje
  If schSCManager = 0 Then
  Begin
    result := GetLastError;
    WriteLn('OpenSCManager error');
    Exit;
  End;

// Kreiramo servis
  schService := CreateService(schSCManager,                { handle do SCManager baze }
                              PAnsiChar(lpServiceName),    { ime servisa }
                              PAnsiChar(lpszDisplayName),  { ime servisa koje se prikazuje (DisplayName kljuc) }
                              SERVICE_ALL_ACCESS,          { setuje privilegije koje imamo nad servisom }
                              dwServiceType,               { tip servisa }
                              dwStartType,                 { nacin na koji OS startuje servis }
                              dwErrorControl,              { nacin na koji OS obradjuje greske kod servisa }
                              PAnsiChar(lpBinaryPathName), { putanja do binary fajla }
                              nil,                         { prioritet izvrsenja servisa }
                              nil,                         { oznaka prioriteta }
                              nil,                         { zavisnost naseg servisa od drugih - nas servis ce se pokrenuti
                                                             samo ako je bar jedan servis od ovde nabrojanih pokrenut       }
                              nil,                         { ime account-a pod kojim se servis pokrece - ovde LocalSystem }
                              nil);                        { lozinka za gore navedeni account - nije potrebna za LocalSystem,
                                                             LocalService, NetworkService i za servise ciji je dwServiceType
                                                             flag = SERVICE_KERNEL_DRIVER ili SERVICE_FILE_SYSTEM_DRIVER      }

// Ako nismo uspeli da kreiramo servis, izlazimo iz fje
  If schService = 0 Then
  Begin
    result := GetLastError;
    WriteLn('CreateService failed');
    Exit;
  End;

// Zatvaramo otvoreni handle
  CloseServiceHandle(schService);
end;

var
  s_name         : String;
  s_displayname  : String;
  s_servicetype  : Integer;
  s_starttype    : Integer;
  s_errorcontrol : Integer;
  res            : Integer;

begin
  Write('Ime servisa                        : ');
  ReadLn(s_name);

  Write('Ime servisa koje se prikazuje      : ');
  ReadLn(s_displayname);

  WriteLn;
  WriteLn('Tip servisa');
  WriteLn('( 1 - SERVICE_KERNEL_DRIVER,');
  WriteLn('  2 - SERVICE_FILE_SYSTEM_DRIVER,');
  WriteLn(' 16 - SERVICE_WIN32_OWN_PROCESS,');
  Write  (' 32 - SERVICE_WIN32_SHARE_PROCESS ): ');
  ReadLn(s_servicetype);

  WriteLn;
  WriteLn('Nacin startovanja servisa');
  WriteLn('( 0 - SERVICE_BOOT_START,');
  WriteLn('  1 - SERVICE_SYSTEM_START,');
  WriteLn('  2 - SERVICE_AUTO_START,');
  WriteLn('  3 - SERVICE_DEMAND_START,');
  Write  ('  4 - SERVICE_DISABLED      )      :');
  ReadLn(s_starttype);

  WriteLn;
  WriteLn('Kontrola gresaka');
  WriteLn('( 0 - SERVICE_ERROR_IGNORE,');
  WriteLn('  1 - SERVICE_ERROR_NORMAL,');
  WriteLn('  2 - SERVICE_ERROR_SEVERE,');
  Write  ('  3 - SERVICE_ERROR_CRITICAL )     :');
  ReadLn(s_errorcontrol);

  res := InstallService(s_name,
                        s_displayname,
                        s_servicetype,
                        s_starttype,
                        s_errorcontrol,
                        ParamStr(0));

  WriteLn;                      
  If res = 0 Then
    WriteLn('Servis uspesno instaliran !')
  else
    WriteLn('Greska prilikom instaliranja servisa ! (error: ', res, ')');
end.

